#ifndef APPMANAGERCGROUPD_H
#define APPMANAGERCGROUPD_H

#include <QObject>
#include <QMap>
#include <QVariant>

struct cgroup;
class SystemResourceWatcher;
class AppManagerCgroupd : public QObject
{
    Q_OBJECT
public:
    explicit AppManagerCgroupd(QObject *parent = nullptr);

    QList<int> pids(const QString &cgroupName);

public Q_SLOTS:
    QMap<QString, QVariant> CreateProcessCGroup(const QString &appId, int pid);

    QMap<QString, QVariant> CreateProcessCGroup(const QString &appId, const QList<int> &pids);

    QMap<QString, QVariant> DeleteProcessCGroup(const QString &cgroupName);

    QMap<QString, QVariant> SetProcessCGroupResourceLimit(const QString &cgroupName, 
                                                          const QString &attrName,
                                                          int value);
    QMap<QString, QVariant> CGroupNameWithPid(int pid);

    QMap<QString, QVariant> PidsOfCGroup(const QString &cgroupName);

Q_SIGNALS:
    void ResourceThresholdWarning(const QString &resource,
                                  const QString &shareTime,
                                  const QString &threshold,
                                  const QString &avg);

private:
    bool initCgroup();
    cgroup *createCgroup(const QString &cgroupName, const QStringList &controllers = QStringList());

    QMap<QString, QVariant> initResult();

private:
    bool m_cgroupInited;
    QString m_cgroupInitErrMsg;
    QStringList m_createdCGroupNames;

    const QString kRootCgroup = "kylin-app-manager";
    const QStringList kControllerNames = { 
        "cpu", "memory", "io", "pids"
    };

    const QString kResult = "result";
    const QString kErrMsg = "errorMessage";
};

#endif // APPMANAGERCGROUPD_H
