#ifndef COMMON_H
#define COMMON_H

#include <QMap>
#include <QVariant>
#include <QString>

namespace common {

typedef QMap<QString, QVariant> DBusResult;
static const char *kDbusResult = "result";
static const char *kDbusErrMsg = "errorMessage";

static DBusResult initDbusResult()
{
    DBusResult result;
    result[kDbusResult] = "";
    result[kDbusErrMsg] = "";
    return result;
}

template<typename T>
class Singleton {
public:
    static T& GetInstance() {
        static T instance;
        return instance;
    }
protected:
    virtual ~Singleton() {}
    Singleton() {}
    Singleton(const Singleton&) {}
    Singleton& operator =(const Singleton&) {}
};

}

#endif // COMMON_H
