#ifndef PRESSUREWATCHER_H
#define PRESSUREWATCHER_H

#include <QObject>
#include <QJsonObject>
#include <QMap>
#include "resourcewatcher.h"
#include "confmanager.h"

class PressureWatcher : public ResourceWatcher
{
    Q_OBJECT
public:
    explicit PressureWatcher(QObject *parent = nullptr);

public Q_SLOTS:
    void start() override;
    void stop() override;

Q_SIGNALS:
    void finished();

private:
    struct PressureTrigger {
        ConfManager::Resource resource;
        ConfManager::ResourceUrgency urgency;
        QString trigger;
        QString fileInterface;
        int fd = -1;
    };

private:
    void initTriggers();
    PressureTrigger trigger(int fd);
    void handleWarningMessage(QMap<ConfManager::Resource, ConfManager::ResourceUrgency> triggerUrgency);

private:
    bool m_stop;
    QList<PressureTrigger> m_triggers;
    QMap<ConfManager::Resource, ConfManager::ResourceUrgencyThrehold> m_resourceThreholds;
};

#endif // PRESSUREWATCHER_H
