#ifndef PROCESSMANAGER_H
#define PROCESSMANAGER_H

#include <QObject>

class AppManagerCgroupd;
class ResourceWatcher;
class ProcessReclaimer;
class ProcessManager : public QObject
{
    Q_OBJECT
public:
    explicit ProcessManager(QObject *parent = nullptr);
    void startWatchers();

    QMap<QString, QVariant> CreateProcessCGroup(const QString &appId, int pid);

    QMap<QString, QVariant> CreateProcessCGroup(const QString &appId, const QList<int> &pids);

    QMap<QString, QVariant> DeleteProcessCGroup(const QString &cgroupName);

    QMap<QString, QVariant> SetProcessCGroupResourceLimit(const QString &cgroupName,
                                                         const QString &attrName,
                                                         int value);

    QMap<QString, QVariant> CGroupNameWithPid(int pid);

    QMap<QString, QVariant> PidsOfCGroup(const QString &cgroupName);

    QMap<QString, QVariant> ReclaimProcesses(const QList<int> &pids);

    QMap<QString, QVariant> ReclaimProcesses(const QString &cgroup);

    QStringList Features() const;

Q_SIGNALS:
    void ResourceThresholdWarning(const QString &resource, int level);

private:
    void startWatcherThread(ResourceWatcher *watcher, QThread *thread);

private:
    AppManagerCgroupd *m_appMgrCgroupd;
    ProcessReclaimer *m_processReclaimer;
};

#endif // PROCESSMANAGER_H
