#ifndef RESOURCEWATCHER_H
#define RESOURCEWATCHER_H

#include <QObject>
#include <QQueue>

class ResourceWatcher : public QObject
{
    Q_OBJECT
public:
    explicit ResourceWatcher(QObject *parent = nullptr);

public Q_SLOTS:
    virtual void start() = 0;
    virtual void stop() = 0;

signals:
    void finished();
    void ResourceThresholdWarning(const QString &resource, int level);

protected:
    bool thresholdWarning(int urgency);

protected:
    int m_detectEffectiveNumber;
    QQueue<int> m_detectValues;
};

#endif // RESOURCEWATCHER_H
